// EXAMPLE CODE OF GENERATION

NMUNS   Noun, Masculine, Unanimated, Nominative, Singular  // Masculine and Unanimated are taken from the dicitonary for nouns, so these two letter are ignored
NFAGP   Noun, Feminine, Animated, Genitive, Plural  // Feminine and Animated are taken from the dicitonary for nouns, so these two letter are ignored

AFNSM  Adjective, Full form, Nominative, Singular, Masculine
AFAP  Adjective, Full form, Accusative, Plural     // No gender in Plural
ABSM  Adjective, Brief form,  Singular, Masculine   //
ABAP  Adjective, Brief form, Plural     // No gender in Plural
AC    Adjective, Comparison form

VF   Verb Infinitive
VIP1S  Verb, Indicitive, Present/Future, 1 person, Singular
VITSM  Verb, Indicitive, Past, Singular, Masculine
VM2S  Verb, Imperative, 2 person, Singular


// Prepare a String with encoded info
function encode_minf (pt:pointer):string;

var o2:^mi;
    st:string;

procedure encode_padej (pad:padej);
begin
  case pad of
   im:  st:=st+'N';
   rod: st:=st+'G';
   dat: st:=st+'D';
   win: st:=st+'A';
   tw:  st:=st+'B';
   pr:  st:=st+'P';
   nul: st:=st+'U';   // unchanging
  end;
end;

procedure encode_chisl(chisl:chislo);
begin
 case chisl of
  ed:st:=st+'S';
  mn:st:=st+'P';
 end;
end;

procedure encode_rod(rod:rodr);
begin
 case rod of
  muj: st:=st+'M';
  jen: st:=st+'F';
  sr:  st:=st+'N';
 end;
end;

procedure encode_wremja(wre:wremq);
begin
 case wre of
  nast:  st:=st+'P';
  proch: st:=st+'T';
  bud:   st:=st+'F';
 end;
end;

procedure encode_od(od:odd);
begin
 case od of
  yod: st:=st+'A';
  nod: st:=st+'U';
 end;
end;

begin
o2:=pt;
st:='';

with o2^ do begin
 case tag of
  s:begin                 // NOUN
      st:=st+'N';

      if (HAS NO IRREGULAR FORMS)
      begin
       encode_rod   (s1.rod);  // GENDER : M, F, N
       encode_od    (s1.od);   // ANIMITY: A, U
       encode_padej (s1.pad);  // CASE   : N, G, D, A, B, P
       encode_chisl (s1.chisl);// NUMBER : S, P
      end
     else st:=st+'U';
    end;

  ms:begin             // PRONOUN
       st:=st+'P';

       encode_padej (p2.pad);    // CASE   : N, G, D, A, B, P
       encode_chisl (p2.chisl);  // NUMBER : S, P

       if  (HAS NO IRREGULAR FORMS)
       then encode_rod(p2.rod);     // GENDER : M, F, N
    end;

  p:begin          // ADJECTIVE
     st:=st+'A';

     if (HAS FORMS) then begin
       case p2.form of
         poln:begin
                 st:=st+'F';             // FULL FORM
                 encode_padej(p2.pad);   // CASE   : N, G, D, A, B, P
                 encode_chisl(p2.chisl); // NUMBER : S, P

                 if (SINGULAR) then
                    encode_rod(p2.rod);  // GENDER : M, F, N
               end;
         krat:begin
               st:=st+'B';   // BRIEF FORM
               encode_chisl(p2.chisl);    // NUMBER : S, P
               if SINGULAR then
                   encode_rod(p2.rod);  // GENDER : M, F, N
              end;
         stepen: st:=st+'C';    // COMPARISON FORM
       end;
      end{if typ>0}
      else st:=st+'U';  // UNCHANGING FORM
     end;

  pri:begin                     // PARTICIPLE (or gerund)
       if p4.deepri=true then
        begin
            st:=st+'G';              // G is gerund

            encode_wremja(p4.wre);   // TIME : P (p=resent), T(=past), F (=future)
         end
       else
        begin
         st:=st+'T';                   // T is participle!

         if p4.strad=true then         
           st:=st+'P'                  // P ( passive )
         else
            st:=st+'A';               //  A (active)

        encode_wremja(p4.wre);      // TIME : P (p=resent), T(=past), F (=future)

        // NOW IT IS THE SAME AS ADJECTIVE
        case p4.form of
        poln:begin
                st:=st+'F';

                encode_padej(p4.pad);

                encode_chisl(p4.chisl);

                if p4.chisl=ed then
                 encode_rod(p4.rod);
         end;
         krat:begin
          st:=st+'B';

          encode_chisl(p4.chisl);

          if p4.chisl=ed then
                  encode_rod(p4.rod);
         end;
        end; // case p4.form
       end; {if prichast}

             if p4.vozvr then
         st:=st+'X';
     end;

  inf:begin                         // INFINITIVE
        st:=st+'VF';                // Verb Infinite

        if g3.vozvr then
           st:=st+'X';             // Reflexive = X
      end;

  g:begin                         // VERB
      st:=st+'V';

      case g3.nakl of            // MOOD
       iz: st:=st+'I';           // Indicative
       pov:st:=st+'M';           // Imperative
      end;

     if Indicative
     then encode_wremja(g3.wre); // TIME : P (p=resent), T(=past), F (=future)

     if (g3.nakl=iz) and (g3.wre=nast)
     then case g3.lic of
          1:st:=st+'1';                 // Person
          2:st:=st+'2';
          3:st:=st+'3';
       end;

      encode_chisl(g3.chisl);        // NUMBER

      if (g3.nakl=iz) and (g3.wre=proch) and (g3.chisl=ed)
      then encode_rod(g3.rod);       // GENDER

      if g3.vozvr then st:=st+'X';   // REFLEXIVE
    end;  // verb

    // OTHER PARTS OF SPEECH
 else begin
       if o2^.tag=narech then
          st:=st+'R';
       if o2^.tag=sojuz then
          st:=st+'C';
       if o2^.tag=predl then
          st:=st+'S';
       if o2^.tag=chastic then
          st:=st+'I';
       if o2^.tag=mejd then
          st:=st+'J';
       if o2^.tag=predic then
          st:=st+'D';
       if o2^.tag=vvodn then
          st:=st+'O'; // not zero, the letter O
       if (o2^.tag=chis) then
          st:=st+'Z';
       if (o2^.tag=ch_p) then
          st:=st+'W';
       if o2^.tag=sravn then
          st:=st+'E';
      end;
  end; {case}
 end; {with}

 encode_minf:=st;
end;



